#include		<tap.h>
#include		"../../libs/FB/libFireBird.h"
#include "..\..\libs\FB\flash\FBLib_flash.h"
#include "..\..\libs\EMJB\GetSkinData.h"

#define PROGRAM_NAME    "Blank Channel RC1"
#define MaxNameOffset 65000
#define MAX_ProviderName 20
#define MaxProviderOffset 65000
#define MaxBlanks 12

TAP_ID                  (0xC54D4A0C);
TAP_PROGRAM_NAME	(PROGRAM_NAME);
TAP_AUTHOR_NAME		("EMJB");
TAP_DESCRIPTION		("Blank channel generator");
TAP_ETCINFO		(__DATE__);

 

/*****************************************************************************************************************************/
/* Prototypes                                                                                                                */
/*****************************************************************************************************************************/
dword TAP_EventHandler(word event, dword param1, dword param2);
int   TAP_Main(void);
int Rgn;
 
 int Large =  FNT_Size_1926;		
 int Medium = FNT_Size_1622;
 int Small = FNT_Size_1419;
 dword LastTime = 0;
	char MStr[200];
dword FreeNameOffset = 0;
word ProviderBlock = 0;
dword ShowTimeEnd = 0;
int ProgRgn = 0;
int MaxX = 720;
int MaxY = 576;


void ShowEMJBMessage (char* lpMessage1, char* lpMessage2, int DisplayTime)			
{
	Show3XMessage (PROGRAM_NAME,lpMessage1, lpMessage2,DisplayTime, BorderCol, Bgd, Font);				//In EMJBTools
}

void ShowProgress (char* lpMessage1, char* lpMessage2, int MinDisplayTime)			
{

								// stores rgn-handle for osd
	dword w;							// stores width of message-text
	int Top = 265;						// Y co-ord of top of text
	
	int LSpacing = 30;
	int TextHt;

	while (TAP_GetTick() < ShowTimeEnd) TAP_Delay(10);
	
	if ((strlen(lpMessage1) != 0) && (MinDisplayTime > 0))
	{
		
		ShowTimeEnd = TAP_GetTick() + MinDisplayTime;
		if (ProgRgn != 0) ProgRgn = TAP_Osd_Create( 0, 0, MaxX, MaxY, 0, FALSE );		// create rgn-handle
		TAP_Osd_FillBox(ProgRgn, 0,0,MaxX,MaxY,ScreenCol);
		w = TAP_Osd_GetW( PROGRAM_NAME, 0, Large ) + 20;		// calculate width of message
		if (TAP_Osd_GetW( lpMessage1, 0, Large ) + 20>w)
		{
			w = TAP_Osd_GetW( lpMessage1, 0, Large ) + 20;	// calculate width of message
		}
			if ((strlen(lpMessage2) > 0) && (TAP_Osd_GetW( lpMessage2, 0, Large ) + 10>w))
		{
			w = TAP_Osd_GetW( lpMessage2, 0, Large ) +20;	// calculate width of message
		}
		if (w > MaxX) w = MaxX;						// if message is to long
		if (strlen(lpMessage2) == 0)						// draw background-box for borderaccording to number of lines
		{	
			TextHt = 2*LSpacing + 22;
		}
		else
		{ 
			TextHt = 3*LSpacing + 22;
		}
	
		TAP_Osd_FillBox(ProgRgn, (MaxX-w)/2+3,Top+3,w-6,TextHt-6,Bgd);
		TAP_Osd_PutUlS(ProgRgn, (MaxX-w)/2, Top+8, (MaxX+w)/2, PROGRAM_NAME,		// show message
			Font, Bgd, 0, Large, FALSE, ALIGN_CENTER);
		TAP_Osd_PutS(ProgRgn, (MaxX-w)/2, Top+LSpacing+12, (MaxX+w)/2, lpMessage1,		// show message
			Font, Bgd, 0, Large, FALSE, ALIGN_CENTER);
		if (strlen(lpMessage2) > 0)
		{															// Shrink font if too large to fit on line
			if (TAP_Osd_GetW( lpMessage2, 0, Large ) < MaxX -20)
			{	TAP_Osd_PutS(ProgRgn, (MaxX-w)/2, Top+2*LSpacing+12, (MaxX+w)/2, lpMessage2, Font, Bgd, 0, Large,FALSE, ALIGN_CENTER);}
			else
			{	if (TAP_Osd_GetW( lpMessage2, 0, Medium) < MaxX -20)
				{	TAP_Osd_PutS(ProgRgn, (MaxX-w)/2, Top+2*LSpacing+12, (MaxX+w)/2, lpMessage2, Font, Bgd, 0, Medium,FALSE, ALIGN_CENTER);}
				else
				{	TAP_Osd_PutS(ProgRgn, (MaxX-w)/2, Top+2*LSpacing+12, (MaxX+w)/2, lpMessage2, Font, Bgd, 0, Small,FALSE, ALIGN_CENTER);}
			}
		}
		DrawRoundedRectangle(ProgRgn, (MaxX-w)/2, Top, w, TextHt, 4, BorderCol);
	}
	else	
	{
		TAP_Osd_FillBox(ProgRgn, 0,0,MaxX,MaxY,0);
		TAP_Osd_Delete(ProgRgn);					// release handle
	}
}


bool MarkChannelDelete(int SvcNo, int  SvcType)
{
	dword Address;
	byte Setting;
	
	if (SvcType == SVC_TYPE_Tv)
		Address = FlashBlockOffset[1];
	else
		Address = FlashBlockOffset[2];
	
	Address = Address + 4 + 32*SvcNo + 3;
	
	memcpy(&Setting,(dword*) Address,1);
	Setting = Setting & 0xF7;
	Setting = Setting + 8;
	memcpy((dword*) Address, &Setting,1);
}

word EMJBFindNextProviderNameTableEntry (void)
{
  dword                 LastEntry = 0;
  TYPE_Service          *Svc;

  if (!LibInitialized) InitTAPex ();
  if (!LibInitialized || (FlashOffset == 0)) return 0;

  //Find the highest service name table pointer in the TV services
  (dword) Svc = FlashBlockOffset [TVServices] + 4;
  while (Svc->TunerNum != 0)
  {
    if (Svc->ProviderIdx > LastEntry) LastEntry = Svc->ProviderIdx;
    Svc++;
  }

  //Repeat for all radio services
  (dword) Svc = FlashBlockOffset [RadioServices] + 4;
  while (Svc->TunerNum != 0)
  {
    if (Svc->ProviderIdx > LastEntry) LastEntry = Svc->ProviderIdx;
    Svc++;
  }

  return LastEntry + 1;
}

int SvcReName (int SvcType, int SvcNo, char* NewName)
{
	dword NamePointerAddress, NewNameAddress, FlagAddress;
	
	char NewText[MAX_SvcName+5], MStr[100];
	byte Flags;
//ShowEMJBMessage("Looking for free name offset","",100);
			// Find first unused part of the name section of flash
		if (FreeNameOffset == 0)
			FreeNameOffset = FlashFindEndOfServiceNameTableAddress()-FlashBlockOffset[10]-4;
		
	if ((FreeNameOffset + MAX_SvcName <  MaxNameOffset) && (strlen(NewName) <= MAX_SvcName))
	{
		memset(NewText,0,sizeof(NewText));
		strcpy(NewText,NewName);
		NewNameAddress = (dword) FreeNameOffset + FlashBlockOffset[10]+ 4;
		if (SvcType == SVC_TYPE_Tv)
			NamePointerAddress = (dword) FlashBlockOffset[1] + 4 + 32*SvcNo + 0x0010;
		else
			NamePointerAddress = (dword) FlashBlockOffset[2] + 4 + 32*SvcNo + 0x0010;

		memcpy((dword*) NamePointerAddress,&FreeNameOffset,4);			//Insert new pointer value
		memset((dword*) NewNameAddress,0,500);							//Ensure 2 zeros at end to indicate last
		memcpy((dword*) NewNameAddress, NewText,strlen(NewText));		//Insert new name
		
		if (SvcType == SVC_TYPE_Tv)
			FlagAddress = FlashBlockOffset[1] + 4 + 32*SvcNo + 0x000E;
		else
			FlagAddress = FlashBlockOffset[2] + 4 + 32*SvcNo + 0x000E;
		memcpy(&Flags,(dword*) FlagAddress,1);
		if (Flags < 128) 
		{
			Flags = Flags + 128;				//set re-name flag unless already set - stops automatic reset to broadcast channel name
			memcpy((dword*) FlagAddress,&Flags,1);
		}

		FreeNameOffset = FreeNameOffset + strlen(NewName) +1;			// Set up FreeNameOffset for next channel, if there is one
		return(1);
	}
	else
	{	return(0);}
	
}


int ProviderReName (int SvcType, int SvcNo, char* NewName)
{
	dword NamePointerAddress, NewNameAddress, Address;
	char NewText[MAX_ProviderName+1];
	int N;
	char* OldName;
	static bool NameAlreadyUsed = FALSE;
	byte Byte1, Byte2;
	
	if (ProviderBlock == 0) ProviderBlock = EMJBFindNextProviderNameTableEntry();

	if ((ProviderBlock < 256) && (strlen(NewName) <= MAX_ProviderName))
	{
		memset(NewText,0,sizeof(NewText));
		TAP_SPrint(NewText,NewName);
//ShowEMJBMessage("Renaming Provider","Changing pointer",300);		
		if (SvcType == SVC_TYPE_Tv)
			NamePointerAddress = (dword) FlashBlockOffset[1] + 4 + 32*SvcNo + 0x0014;
		else
			NamePointerAddress = (dword) FlashBlockOffset[2] + 4 + 32*SvcNo + 0x0014;
		NewNameAddress = FlashBlockOffset[11] + 4 + 21*ProviderBlock;	
		memcpy((dword *) NamePointerAddress,&ProviderBlock,2);			//Insert new pointer value
		if (!NameAlreadyUsed)
		{
//ShowEMJBMessage("Renaming Provider","Inserting new name",300);
			memset((dword *) NewNameAddress,0,42);			//Ensure next two blocks set to all zeros to indicate last
			memcpy((dword *) NewNameAddress, NewText,strlen(NewText));		//Insert new name
			NameAlreadyUsed = TRUE;
		}
		return(1);
	}
	else
		return(0);
}

void CopyChannel(int SvcType, int OldSvcNo,int NewSvcNo)											// Copies channel to end of list
{
	dword SourceStartAddress, DestStartAddress;
	int CopyLength, i, nTv, nRad;
	
	TAP_Channel_GetTotalNum(&nTv,&nRad);
	
	if (SvcType == SVC_TYPE_Tv)
	{
		SourceStartAddress = (dword) FlashBlockOffset[1] + 32*OldSvcNo + 4 ;  //+ 4 for the initial CRC
		DestStartAddress = (dword) NewSvcNo*32 + FlashBlockOffset[1] + 4;
	}
	else
	{
		SourceStartAddress = (dword) FlashBlockOffset[2] + 32*OldSvcNo + 4;  //+ 4 for the initial CRC
		DestStartAddress = (dword) NewSvcNo*32 + FlashBlockOffset[2] +  4;
	}
		
	memcpy((dword*) DestStartAddress,(dword*) SourceStartAddress, 32);
	memset((dword*) (DestStartAddress+32),0,32);					//Make sure next 32 bytes are zero
}	

void LcnRenumber (int SvcType, int SvcNo, word NewLcn)
{
	word OldValue;
	dword LcnAddress;
		
	if (SvcType == SVC_TYPE_Tv)
		LcnAddress = FlashBlockOffset[1] + 4 + 32*SvcNo + 0x16;
	else
		LcnAddress = FlashBlockOffset[2] + 4 + 32*SvcNo + 0x16;
		
	memcpy((dword *) LcnAddress, &NewLcn, 2);
}


word CRCTable[] =
{
  0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241, 0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
  0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40, 0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
  0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40, 0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
  0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641, 0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
  0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240, 0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
  0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41, 0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
  0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41, 0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
  0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640, 0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
  0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240, 0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
  0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41, 0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
  0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41, 0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
  0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640, 0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
  0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241, 0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
  0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40, 0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
  0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40, 0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
  0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641, 0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040
};

word CalcRAMCRC (dword StartAddress, dword EndAddress)
{
  volatile byte         *pData;
  word                  CRC;

  CRC=0;
  for ((dword) pData=StartAddress; (dword) pData<=EndAddress; pData++)
  {
    CRC= CRCTable [*pData ^ (CRC & 0x00FF)] ^ (CRC >> 8);
  }
  return CRC;
}


void UpdateCRCs(void)
{
	int i;
	
	for (i = TVServices; i < BLOCKS; i++)
  {
    if (FlashBlockOffset [i] != FlashBlockOffset [i + 1]) *(word *) (FlashBlockOffset [i]) = CalcRAMCRC (FlashBlockOffset [i] + 4, FlashBlockOffset [i + 1] - 1);
  }
}

bool UpdateChannelList(SvcType)
{	
	dword updateCh = FindInstructionSequence( 
   "0018c700 031ec024 130000c3 00000000 02602025 0c0639fd 24050001 8f989e54 00137940 030fc021 97050014 0c064325 02602025", 
   "FFFFFFFF FFF0FFFF FFFFFF00 FFFFFFFF FF0FFFFF FC000000 FFFFFFFF FFFF0000 FFF0FFFF FFFFFFFF FFFFFFFF FC000000 FF0FFFFF", 
   0x80140000, 0x801c0000, 0, TRUE);
   dword updateFlash = FindInstructionSequence( 
   "979984de 13200004 0000f025 24190001 1000011c a39984e0 0c000e42", 
   "FFFF0000 FFFFFFFF FFFFFFFF FFFFFFFF FFFFFF00 FFFF0000 FC000000", 
   0x80160000, 0x80200000, 0, TRUE); 

   
	if ((updateCh == 0) || (updateFlash == 0))
		return(FALSE);
	else
	{
		if (SvcType >= 0) 
		{
			CallFirmware(updateCh,0,0,0,0);
			TAP_Channel_Start(1,SvcType,0);
			CallFirmware(updateFlash,0,0,0,0);
		}
		return(TRUE);
	}
}

bool UpdateSettingsFromFlash(void)								// Synchronises general settings with the flash data held in memory
{
	dword ret;
	char MStr[100];
	dword checkSrvInfo = FindInstructionSequence( 
   "a780a154 8f88a134 9382a152 00005025 3404ffff 3403ffff 00004825 91070000 00e2082a 5020001b 95190002 95050002", 
   "FFFF0000 FFFF0000 FFFe0000 FFFFb0FF FFFeFFFF FFF8FFFF FFFFFFFF FFFeFFFF FFdeFFFF FFFFFF00 FFFFFFFF FFFdFFFF", 
   0x80160000, 0x80200000, 0, FALSE); 
 
	if(checkSrvInfo == 0) 
		return(FALSE);
	else	
	{
		CallFirmware(checkSrvInfo,0,0,0,0);
		return (TRUE);
	}
}

void ChangeSettings(int SvcType, int SvcNo, word VPid,word APid,word PcrPid,word PmtPid,word SvcId)
{
	dword BaseAddress, ChangeAddress;
	
	if (SvcType == SVC_TYPE_Tv)
		BaseAddress = FlashBlockOffset[1] + 4 + 32*SvcNo;
	else
		BaseAddress = FlashBlockOffset[2] + 4 + 32*SvcNo;
//TAP_SPrint(MStr," CHANGE SETTINGS: BaseAddress: 0x%8X, ",BaseAddress);
//AddLogMessage(MStr);
//WriteLogFile();	
//ShowEMJBMessage("Changing parameters","",200);		
	ChangeAddress = BaseAddress+0x0004; memcpy((dword*)ChangeAddress,&SvcId,2);
	ChangeAddress = BaseAddress+0x0006; memcpy((dword*)ChangeAddress,&PmtPid,2);
	ChangeAddress = BaseAddress+0x0008; memcpy((dword*)ChangeAddress,&PcrPid,2);					// Deletes all "blank" channels except BBC1 copy
	ChangeAddress = BaseAddress+0x000A; memcpy((dword*)ChangeAddress,&VPid,2);
	ChangeAddress = BaseAddress+0x000C; memcpy((dword*)ChangeAddress,&APid,2);					// Deletes all "blank" channels except BBC1 copy
}
	
void MakeAndDeleteTimer(char* TimerFileName)
{

  TYPE_TimerInfo        tTimerInfo;
  int                   Ret, i, TimerNo;

  if (strlen(TimerFileName) == 0) strcpy(TimerFileName,"Test Timer");
  tTimerInfo.isRec = 0;
  tTimerInfo.tuner = 0;
  tTimerInfo.svcType = 0;
  tTimerInfo.svcNum = 0;
  tTimerInfo.reservationType = RESERVE_TYPE_Onetime;
  tTimerInfo.startTime = TIMER_DATE;
  tTimerInfo.duration = 1;
  tTimerInfo.nameFix = 1;
  TAP_SPrint (tTimerInfo.fileName, TimerFileName);
  Ret = TAP_Timer_Add (&tTimerInfo);
  WaitWhileProcess(200);
  if (Ret == 0)
  {
//ShowEMJBMessage("Successfully added test timer", "",100);
//	AddLogMessage("Reported success in adding test timer");		  
    TimerNo = TAP_Timer_GetTotalNum ();
    for (i = 0; i < TimerNo; i++)
    {
      TAP_Timer_GetInfo (i, &tTimerInfo);
      if (tTimerInfo.startTime == TIMER_DATE && strcmp(tTimerInfo.fileName, TimerFileName) == 0)
      {
//       AddLogMessage("Found test timer in list ready to delete");	
		if (TAP_Timer_Delete (i))
		{
//ShowEMJBMessage("Test timer delete reported successful", "",100);	
//			AddLogMessage("Test timer delete reported successful");
		}
		else
		{
//ShowEMJBMessage("Failed to delete test timer", "",300);	
//			LogError("Test timer delete reported unsuccessful");
		}
		break;
      }
    }
	WaitWhileProcess(200);											// to copy timers into Flash
	for (i = 0; i < TimerNo; i++)
    {
		TAP_Timer_GetInfo (i, &tTimerInfo);
		if (tTimerInfo.startTime == TIMER_DATE && strcmp(tTimerInfo.fileName, TimerFileName) == 0)
		{
			ShowEMJBMessage("'Blank Channel TAP' timer not deleted", "Please Delete manually from your timer list",700);
//			LogError("Test timer not actually deleted");
		}
	}
  }
  else
  {

  }
}

dword TAP_EventHandler(word event, dword param1, dword param2)
{
  int l,m, nTv, OrignTv, nRad, BlankChNo, Method;
  char NewName[30], MStr[100];
  word SysID = *((volatile word*)0xa3fffffa);
  static bool Done = FALSE;
  bool DoneBefore;
  dword  Frequency, ChannelNumber, ChannelDoneList[MaxBlanks];
  word  NewLcn, OldLcn, OldLcnList[MaxBlanks];
  TYPE_TapChInfo ChInfo;
  
  (void) param2;
  
	if (event == EVT_IDLE)
	{
		if (!Done)
		{
			ShowProgress("About to generate blank channels","Initialising services",150);
			Done = TRUE;
			if (FlashInitialize (SysID) != 0) 
			{
				TAP_Channel_Stop(0);							// Shut down TV 
				TAP_Channel_Stop(1);
				ShowProgress("First deleting old blank channels","(i.e. those with LCN in 900 series)" ,150);

						// Delete old blanks - i.e. those with LCN > 900
				TAP_Channel_GetTotalNum(&nTv,&nRad);
				for (m=0;m<nTv;m++)
				{
					TAP_Channel_GetInfo(SVC_TYPE_Tv,m,&ChInfo);
					OldLcn = (int) ChInfo.logicalChNum;
					if (OldLcn >= 900) MarkChannelDelete(m, SVC_TYPE_Tv);
				}
				UpdateSettingsFromFlash();
				UpdateChannelList(SVC_TYPE_Tv);
				
						// Copy one channel from each mux to end of TV list & changing LCN
				ShowProgress("Old blank channels have been deleted","Copying 1 channel from each Mux & renumbering 901 ...",150);
				for (l=0;l<MaxBlanks;l++) ChannelDoneList[l] = 0;
				TAP_Channel_GetTotalNum(&OrignTv,&nRad);
				BlankChNo = 0;
				for (m=0;m<OrignTv;m++) if (BlankChNo < MaxBlanks)				// Search for next new Mux in orignal TV list
				{
					FlashGetChannelNumber(SVC_TYPE_Tv, m, &Frequency, &ChannelNumber); 
					DoneBefore = FALSE;
					for (l=0;l<BlankChNo;l++) if (ChannelNumber == ChannelDoneList[l]) DoneBefore = TRUE; 
					if (!DoneBefore)
					{
						ChannelDoneList[BlankChNo] = ChannelNumber;
						CopyChannel(SVC_TYPE_Tv,m,OrignTv+BlankChNo);
						NewLcn = (word) 901 +BlankChNo;
						LcnRenumber(SVC_TYPE_Tv,OrignTv+BlankChNo, NewLcn);
						TAP_Channel_GetInfo(SVC_TYPE_Tv,m,&ChInfo);			
						OldLcnList[BlankChNo] = ChInfo.logicalChNum;
						BlankChNo++;
					}
				}
				UpdateSettingsFromFlash();
				UpdateChannelList(SVC_TYPE_Tv);
				
				TAP_Channel_GetTotalNum(&nTv,&nRad);			// Check have actually generated the new channels
				if (nTv != OrignTv + BlankChNo)
				{
					ShowProgress("Failed to copy channels correctly","TAP Closing Down",500);
				}
				else
				{												//Modify copies as required
					ShowProgress("Now modifying the copies to form blanks","and saving to Flash memory",150);

					for (l=0;l<BlankChNo;l++)
					{
						m = l + OrignTv;
						switch ((int)OldLcnList[l])
						{	
							case(1/*,2,7,70,80,105*/): strcpy(NewName,"Blank for Mux 1"); break;
							case(3/*,6,10,13,14,28,29*/): strcpy(NewName,"Blank for Mux 2"); break;  //N.B Ch4 is on Mux A in Wales
							case(5/*,16,17,35,36,88,97*/): strcpy(NewName,"Blank for Mux A"); break;
							case(9/*,71,81,87,301,303*/): strcpy(NewName,"Blank for Mux B"); break;
							case(11/*,19,30,82,304*/): strcpy(NewName,"Blank for Mux C"); break;
							case(12/*,18,20,32,300*/): strcpy(NewName,"Blank for Mux D"); break;
							default: strcpy(NewName,"Blank for unknown Mux"); break;
						}
						SvcReName (SVC_TYPE_Tv, m, NewName);
					}

//ShowProgress("Now modifying the copies to turn into blanks","",150);
					for (l=0;l<BlankChNo;l++)
					{
						m = l + OrignTv;
						ChangeSettings(SVC_TYPE_Tv,								// TV/Radio
										m,										// Toppy channel number
										8192,									// Video PID
										0 + 0x8000,								// Audio Pid - Bit 15 must be "1"
										8191,									// PCR Pid
										65535,									// PMT Pid
										0);										// Service ID
					}

					//ShowProgress("Now changing the Provider name","(To identify as made by this TAP)",150);
					for (l=0;l<BlankChNo;l++)
					{
						m = l + OrignTv;
						ProviderReName(SVC_TYPE_Tv, m,"Blank Channel TAP");
					}   

											//This works but requires reboot
					UpdateCRCs();
					MakeAndDeleteTimer("Blank Channel TAP");			
					ShowProgress("All blank channels successfully generated","Your Toppy will now reboot",300);
					ShowProgress("","",0);
					Reboot(FALSE);
				}			// End of correctly generated copies with new LCNs
				ShowProgress("","",0);
			}
			else
			{
				ShowEMJBMessage("Flash Initialisation failure","",500);
			}
			
			TAP_Exit();
		}
	}
   return param1;
}


int TAP_Main(void)
{
	TYPE_PlayInfo 	playInfo;
	TYPE_RecInfo 	recInfo;
	bool Recording0;
	
	LoadSkinData("BlankChannel",FALSE);
	TAP_Hdd_GetPlayInfo (&playInfo);								// Check whether recording or replaying - if so exit
	TAP_Hdd_GetRecInfo(0, &recInfo );
	Recording0 =(recInfo.recType == RECTYPE_Normal) || (recInfo.recType == RECTYPE_Copy);
	TAP_Hdd_GetRecInfo(1, &recInfo );
	if ((Recording0) || (recInfo.recType == RECTYPE_Normal) || (recInfo.recType == RECTYPE_Copy) || (playInfo.playMode != PLAYMODE_None))
	{
		ShowEMJBMessage("Recording/Copy In Progress","TAP Closing Down",500);
		return(0);
	}
	else 
		return 1;
}

